;;; usart driver

; which usart to use?
.if usart = 0
  .equ UCSRA = UCSR0A
  .equ UCSRB = UCSR0B
  .equ UCSRC = UCSR0C
  .equ UBRRL = UBRR0L
  .equ UBRRH = UBRR0H
  .equ UDR = UDR0
.endif

.if usart = 1
  .equ UCSRA = UCSR1A
  .equ UCSRB = UCSR1B
  .equ UCSRC = UCSR1C
  .equ UBRRL = UBRR1L
  .equ UBRRH = UBRR1H
  .equ UDR = UDR1
.endif

;; bit definitions

; UCSRA
.equ RXC = 7
.equ TXC = 6
.equ UDRE = 5
.equ FE = 4
.equ DOR = 3
.equ PE = 2
.equ U2X = 1
.equ MPCM = 0

; UCSRB
.equ RXCIE = 7
.equ TXCIE = 6
.equ UDRIE = 5
.equ RXEN = 4
.equ TXEN = 3
.equ UCSZ2 = 2
.equ RXB8 = 1
.equ TXB8 = 0

; UCSRC
.equ UMSEL = 6
.equ UPM1 = 5
.equ UPM0 = 4
.equ USBS = 3
.equ UCSZ1 = 2
.equ UCSZ0 = 1
.equ UCPOL = 0

;; key
;;
;; ( -- char )
;;
;; fetch character from uart

link_
.db "key",0

key:
  ; wait for character received flag
  in_ temp0,UCSRA
  andi temp0,(1<<RXC)
  brne key_rxc

  rcall pause
  rjmp key
  
key_rxc:
  dup_

  ; read character
  clr tosh
  in_ tosl,UDR
  ret


;; emit
;;
;; ( char -- )
;;
;; send character to uart

link_
.db "emit",0,0

emit:
  ; wait for uart data register empty flag
  in_ temp0,UCSRA
  andi temp0,(1<<UDRE)
  brne emit_udre

  rcall pause
  rjmp emit

emit_udre:
  ; send character
  out_ UDR,tosl

  ; get new TOS
  drop_
  ret

