;;; access io registers

;; use io address instead of
;; memory mapped address if
;; possible

.macro in_
.if (@1 >= $20) && (@1 < $60)
  in @0,@1-$20
.else
  lds @0,@1
.endif
.endmacro

.macro out_
.if (@0 >= $20) && (@0 < $60)
  out @0-$20,@1
.else
  sts @0,@1
.endif
.endmacro

.macro sbic_
.if (@0 >= $20) && (@0 < $40)
  sbic @0-$20,@1
.else
  in_ @2,@0
  sbrc @2,@1
.endif
.endmacro

.macro sbis_
.if (@0 >= $20) && (@0 < $40)
  sbis @0-$20,@1
.else
  in_ @2,@0
  sbrs @2,@1
.endif
.endmacro

.macro sbi_
.if (@0 >= $20) && (@0 < $40)
  sbi @0-$20,@1
.else
  .error "argument not in i/o range"
.endif
.endmacro

.macro cbi_
.if (@0 >= $20) && (@0 < $40)
  cbi @0-$20,@1
.else
  .error "argument not in i/o range"
.endif
.endmacro

